<?php

/**
 * detalle_presupuestal actions.
 *
 * @package    controlComisiones
 * @subpackage detalle_presupuestal
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class detalle_presupuestalActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_DETALLE_PRESUP',
        'PR_RUBRO_PRESUP_V',
        'PROYECTOS',
        'OBJETOS_GASTO',
        'AREA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'PR_RUBRO_PRESUP_V' =>
        array(
            'id_rubro' => 'COM_DETALLE_PRESUP'
        ),
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_DETALLE_PRESUP'
        ),
        'OBJETOS_GASTO' =>
        array(
            'id_obj_gasto-id' => 'COM_DETALLE_PRESUP'
        ),
        'AREA' =>
        array(
            'id_area_lider-id_area' => 'PROYECTOS'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_DETALLE_PRESUP' =>
        array(
            'id_detalle_presup' => 'id_detalle_presup',
            'id_rubro' => 'id_rubro',
            'id_proyecto' => 'id_proyecto',
            'id_obj_gasto' => 'id_obj_gasto',
            'valor_asignado' => 'valor_asignado',
            'id_anhos' => 'id_anhos',
        ),
        'PR_RUBRO_PRESUP_V' =>
        array(
            'rubro' => 'rubro',
            'descripcion' => 'descripcion_rubro'
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm',
            'codigo,||, - ,||,descripcion' => 'completo_cm'
        ),
        'OBJETOS_GASTO' =>
        array(
            'codigo' => 'codigo_ob',
            'descripcion' => 'descripcion_obj'
        ),
        'AREA' =>
        array(
            'codigo' => 'codigo_area',
            'descripcion' => 'descripcion_area',
            'codigo,||, - ,||,descripcion' => 'completo_area'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_DETALLE_PRESUP' =>
        array(
            'id_detalle_presup,a' => array('!=' => array(-1)),
            'id_detalle_presup,b' => array('=' => array('id_detalle_presup')),
            'id_proyecto' => array('=' => array('id_proyecto')),
            'id_rubro' => array('=' => array('id_rubro')),
            'id_obj_gasto' => array('=' => array('id_obj_gasto')),
            'id_anhos' => array('=' => array('id_anhos')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_detalle_presup'; //identificador de la tabla
    protected $id_names = array('id_detalle_presup'); //llave primaria
    protected $field_names = array('id_rubro', 'id_proyecto', 'id_obj_gasto', 'valor_asignado', 'id_anhos'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_DETALLE_PRESUP'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_detalle_presup'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_rubro = $request['id_rubro'];
        $id_obj_gasto = $request['id_obj_gasto'];
        $id_proyecto = $request['id_proyecto'];
        $id_anhos = $request['id_anhos'];


        /*
         *  Validar la operación, ya sea por SQL
         */

        $sql = <<<EOD
select count(*) cantidad FROM COM_DETALLE_PRESUP where id_proyecto = $id_proyecto and id_rubro = $id_rubro and id_obj_gasto = $id_obj_gasto
                and id_anhos = $id_anhos
EOD;

        $records = CN_TABLE::executeSQL($sql);
        $cantidad = $records[0]['cantidad'];

        if ($cantidad > 0) {

            $errors['mensaje'] = "Ya se registro valor para esta configuración";
            $errors['servicio'] = "detalle_presupuestal";
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
